import re
import bpy


def dxt_add(context, sr,
            *,
            render_res):
    
    fullp = "^(DXT_Export_helper_)([0-9]+)$"
    pat1 = "[0-9]+"
    regfp = re.compile(fullp)
    reg1 = re.compile(pat1)
    ixs = []
    
    for obj in bpy.data.objects:
        if "DXT_Export_helper" in obj.name and obj.type == "EMPTY":
            
            if regfp.match(obj.name):
                ixi = reg1.search(obj.name).group()
                if ixi not in ixs:
                    ixs.append(ixi)
                else:
                    sr.report({"ERROR"}, f"The index of the object {obj.name} is used twice. \nCheck your export helpers, and make sure they have unique indices.")
                    return {"FINISHED"}
            else:
                sr.report({"ERROR"}, f"The name formatting of the object {obj.name} is wrong. \nCheck your export helpers.")
                return {"FINISHED"}
    
    ix = 1
    for uix in ixs:
        c = int(uix)
        if c >= ix:
            ix = c + 1
    
    obj = bpy.data.objects.new(f"DXT_Export_helper_{ix}", None)
    context.scene.collection.objects.link(obj)
    
    obj["render_res"] = render_res
    
    return {'FINISHED'}
