from os import path
import inspect
import platform
import subprocess
import time

from . import zutil


path_vips = ""
fn = inspect.getframeinfo(inspect.currentframe()).filename
path_exec = path.dirname(path.dirname(path.abspath(fn)))

if platform.system() == "Windows":
    path_vips = path.normpath(path.join(path_exec, "vips", "vips.exe"))
else:
    path_vips = path.normpath(path.join(path_exec, "vips", "vips"))


# hasalpha
def vips_is_transparent(path_img):
    # this is currently a placeholder
    # TODO: implement alpha band inspect.
    return False


# img create
def vips_create(path_img, size_x, size_y, r, g, b, a, EX_CLEAN):
    name, ext = path.splitext(path.basename(path_img))
    path_dir = path.dirname(path_img)
    path_svg = path.join(path_dir, f"{name}.svg")
    # path_vimg = path.join(path_dir, f"{name}.VipsImage")
    
    chex = "%02x%02x%02x" % (r, g, b)
    ca = a / 255
    
    svgb = ""
    svgb += f"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"{size_x}\" height=\"{size_y}\">\n"
    svgb += f"\t<rect width=\"100%\" height=\"100%\" fill=\"#{chex}\" fill-opacity=\"{ca}\" />\n"
    svgb += "</svg>"
    
    with open(path_svg, mode="w", encoding="UTF-8") as fp:
        fp.write(svgb)
    
    cmd = [path_vips, "svgload", path_svg, path_img]
    proc = subprocess.Popen(cmd)
    
    while proc.poll() is None:
        time.sleep(0.050)
    
    if EX_CLEAN:
        zutil.rmfile(path_svg)
    
    return True