# from math import cos, sin
#
#
# #  x  y  z
# #  x  z -y
#
# # Eq: Rx(-90)
# def cc(l) -> list:
#     return [l[0], l[2], -l[1]]
#
#
# def Rx(t, array):
#     m = [[1,   0,      0      ],
#          [0,   cos(t), -sin(t)],
#          [0,   sin(t), cos(t) ]]
#
#     return matmult(m, array)
#
#
# def Ry(t, array):
#     m = [[cos(t),  0, sin(t)],
#          [0,       1, 0     ],
#          [-sin(t), 0, cos(t)]]
#
#     return matmult(m, array)
#
#
# def Rz(t, array):
#     m = [[cos(t), -sin(t), 0],
#          [sin(t), cos(t),  0],
#          [0,      0,       1]]
#
#     return matmult(m, array)
#
#
# def matmult(rotmat, b):
#     rtv = list()
#     for sor in rotmat:
#         # rot: [x, y, z]
#         rtv.append((int)(sor[0] * b[0]) + (int)(sor[1] * b[1]) + (int)(sor[2] * b[2]))
#
#     return rtv


import math
from copy import deepcopy


def dict_merge(target, *args):
    # Merge multiple dicts
    if len(args) > 1:
        for obj in args:
            dict_merge(target, obj)
        return target
    
    # Recursively merge dicts and set non-dict values
    dct = args[0]
    if not isinstance(dct, dict):
        return dct
    for k in dct:
        v = dct[k]
        if k in target and isinstance(target[k], dict):
            dict_merge(target[k], v)
        else:
            target[k] = deepcopy(v)
    return target


def dict_compare(d1, d2):
    print(f"compare: {d1} {d2}")
    if d1.keys() != d2.keys():
        print(f"return false, keys")
        return False
    for key in d1:
        print(f"compare: {d1[key]} {d2[key]}")
        if d1[key] != d2[key]:
            print(f"return false, {d1[key]} {d2[key]}")
            return False
    print(f"return true")
    return True


def cpfile(src, dst_folder):
    import shutil
    from os import path
    basename = path.basename(src)
    dst = path.join(dst_folder, basename)
    if src != dst:
        shutil.copyfile(src, dst)
    return basename

def rmfile(fp):
    from os import path
    from os import unlink
    if path.exists(fp):
        unlink(fp)
    else:
        return False
    return True


def vec_magnitude(v):
    return math.sqrt(sum(v[i]*v[i] for i in range(len(v))))


def vec_add(u, v):
    return [u[i]+v[i] for i in range(len(u))]


def vec_sub(u, v):
    return [u[i]-v[i] for i in range(len(u))]


def vec_dot(u, v):
    return sum(u[i]*v[i] for i in range(len(u)))


def vec_normalize(v):
    vmag = vec_magnitude(v)
    return [v[i]/vmag for i in range(len(v))]


def scale(val, in_min, in_max, out_min, out_max):
    rg_in = in_max - in_min # 1 - 0 = 1
    rg_out = out_max - out_min # 255 - 0 = 255
    scaled = out_min + (((val - in_min) / rg_in) * rg_out) # 0 + (((x - 0) / 1) * 255)
    return scaled


def rgbtrx(c):
    srgb = 0
    if c < 0.0031308:
        srgb = 0.0 if c < 0.0 else c * 12.92
    else:
        srgb = 1.055 * math.pow(c, 1.0 / 2.4) - 0.055
    return srgb


def rgbscale(val):
    return int(scale(rgbtrx(val), 0, 1, 0, 255))


def clamp(val, _min, _max):
    return max(_min, min(val, _max))


def squish(val: float, amp: float, bias: float) -> float:
    return (val * amp) / (abs(val) + bias)

def isclose(val_a: float, val_b:float, tol:float = 0.00000001)->bool:
    if abs(val_a - val_b) <= tol:
        return True
    return False
